if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface Index_Params {
    context?;
}
import type common from "@ohos:app.ability.common";
import promptAction from "@ohos:promptAction";
import router from "@ohos:router";
import hilog from "@ohos:hilog";
const DOMAIN_NUMBER: number = 0xFF00;
const TAG: string = '[EventAbility]';
class Index extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.context = getContext(this) as common.UIAbilityContext;
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Index_Params) {
        if (params.context !== undefined) {
            this.context = params.context;
        }
    }
    updateStateVars(params: Index_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private context;
    eventHubFunc(): void {
        // 不带参数触发自定义"event1"事件
        this.context.eventHub.emit('event1');
        // 带1个参数触发自定义"event1"事件
        this.context.eventHub.emit('event1', 1);
        // 带2个参数触发自定义"event1"事件
        this.context.eventHub.emit('event1', 2, 'text');
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 10 });
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('Open Second Page');
            Button.onClick(() => {
                router.pushUrl({ url: 'pages/Second' });
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel({ "id": 16777228, "type": 10003, params: [], "bundleName": "com.example.uiabilitydata", "moduleName": "entry" });
            Button.onClick(() => {
                this.eventHubFunc();
                promptAction.showToast({
                    message: { "id": 16777228, "type": 10003, params: [], "bundleName": "com.example.uiabilitydata", "moduleName": "entry" }
                });
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel({ "id": 16777229, "type": 10003, params: [], "bundleName": "com.example.uiabilitydata", "moduleName": "entry" });
            Button.onClick(() => {
                hilog.info(DOMAIN_NUMBER, TAG, 'event1 off');
                this.context.eventHub.off('event1');
                promptAction.showToast({
                    message: { "id": 16777229, "type": 10003, params: [], "bundleName": "com.example.uiabilitydata", "moduleName": "entry" }
                });
            });
        }, Button);
        Button.pop();
        Column.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "Index";
    }
}
registerNamedRoute(() => new Index(undefined, {}), "", { bundleName: "com.example.uiabilitydata", moduleName: "entry", pagePath: "pages/Index", pageFullPath: "entry/src/main/ets/pages/Index", integratedHsp: "false" });
